*
* Getting the result in a Stata matrix is slowing down the analysis
* Users who want to analyze the distance matrix using another software may wish
* to turn it off
*
program seqcomp
	version 9
	syntax varlist [if] [iw/] [using/] [,id(varname) export nodistmat]  
	marksample touse
	if (substr(`"`if'"',1,2)== "if") {
		/*display "boucle if ok"*/
		tokenize `if'
		local first `1'
		mac shift
		local ifrest `*'
		/*display "`ifrest'"*/
	}
	if (`"`weight'"'== "")	{
		/*display "No weights are used"*/
		ge wt_=1
	} 
 	else {
 		display "Weights used: `exp'"
 		quietly ge wt_=`exp'
 		quietly count `if'
 		local n1=r(N)
		if (substr(`"`if'"',1,2)== "if") {
 			quietly count if `ifrest' & `exp'<.
		}
		else {
			quietly count if `exp'<.
		}
 		local n2=r(N)
 		local n3=`n1'-`n2'
 		if (`n3'!=0) display "Warning! `exp' contains `n3' missing values: corresponding sequences are not analyzed"
 	} 
	if (`"`id'"'== "")	{
		display "No id variable provided 1 to N will be used"
		ge id_=_n
	} 
	else ge id_=`id'
	if ("`distmat'"'!="nodistmat") {
 		quietly count `if'
		local matrixsize=r(N)	
		mata: distmat(`matrixsize')
		*matrix dhamdist=r(dist)
	}
	if (`"`export'"'=="export") {
		if ("`distmat'"'=="nodistmat") {
			plugin call distseq `varlist' wt_ id_ `if', "`using'" "nodhamdist"
		}
		else {
			plugin call distseq `varlist' wt_ id_ `if', "`using'" dhamdist
		}
	}
	else {
		if ("`distmat'"'=="nodistmat") {
			display "You have to save the results somewhere! Execution aborted"
		}
		else {
			plugin call distseq `varlist' wt_ id_ `if', "no" dhamdist
		}	
	}
	drop wt_ id_
end
program distseq, plugin 

version 9
mata: 
matrix function distmat(real scalar n) {
	dist=J(n,n,0)
	st_matrix("dhamdist",dist)
}
end
